#
# spec file for package libapr-util1 (Version 1.2.8)
#
# Copyright (c) 2009 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# norootforbuild
# usedforbuild    aaa_base acl attr audit-libs autoconf automake bash binutils brp-check-internal bzip2 coreutils cpio cpp cpp42 cracklib cvs cyrus-sasl cyrus-sasl-devel diffutils doxygen file filesystem fillup findutils gawk gcc gcc42 gdbm gettext gettext-devel glibc glibc-devel glibc-locale grep groff gzip info insserv keyutils-libs krb5 less libacl libapr1 libapr1-devel libattr libbz2-1 libbz2-devel libcom_err2 libdb-4_5 libdb-4_5-devel libexpat-devel libexpat1 libgcc42 libgomp42 libltdl-3 libmudflap42 libmysqlclient-devel libmysqlclient15 libmysqlclient_r15 libopenssl-devel libopenssl0_9_8 libpng libreadline5 libstdc++42 libtool libuuid1 libvolume_id libxcrypt libzio linux-kernel-headers m4 make man mktemp ncurses net-tools netcfg openldap2 openldap2-client openldap2-devel openslp openssl-certs pam pam-modules patch perl perl-base permissions popt post-build-checks postgresql-devel postgresql-libs rpm sed sqlite sqlite-devel sysvinit tar tcpd texinfo timezone util-linux zlib zlib-devel


Name:           libapr-util1
%define with_sqlite2 0
%define with_sqlite3 0
%define with_mysql 0
%define with_pgsql 0
%define with_dso 0
%if 0%{?suse_version} >= 910
  %define with_sqlite2 1
  %define with_mysql 1
  %define with_pgsql 1
  %define with_dso 1
%endif
%if 0%{?suse_version} >= 930
  %define with_sqlite2 0
  %define with_sqlite3 1
%endif
#
#
BuildRequires:  db-devel libapr1-devel
#
#
# database backends
#
%if %{with_mysql}
BuildRequires:  mysql-devel
%endif
#
%if %{with_sqlite2}
BuildRequires:  sqlite-devel
%endif
%if %{with_sqlite3}
BuildRequires:  sqlite-devel
%endif
#
%if %{with_pgsql}
BuildRequires:  postgresql-devel
%endif
#
#
# distro specific buildrequires
#
%if %{?suse_version:1}0
BuildRequires:  doxygen openldap2 openldap2-devel
%endif
%if 0%{?suse_version} > 1020
BuildRequires:  libexpat-devel
%else
BuildRequires:  expat
%endif
%if %{?fedora_version:1}0
BuildRequires:  expat-devel openldap2-devel
%endif
%if %{?mandriva_version:1}0
BuildRequires:  expat-devel libldap2.3_0-devel
%endif
#
Url:            http://apr.apache.org/
License:        Other uncritical OpenSource License; The Apache Software License
Group:          Development/Libraries/Other
AutoReqProv:    on
Version:        1.2.8
Release:        68.4
Summary:        Apache Portable Runtime (APR) Library
Source:         http://www.apache.org/dist/apr/apr-util-%{version}.tar.bz2
# http://people.apache.org/~niq/dbd.html
Source1:        http://apache.webthing.com/svn/apache/apr/apr_dbd_mysql.c
Patch:          apr-util-1.2.7.diff
Patch1:         apr-util.expat.patch
Patch2:         apr-util-1.2.8_dbd_mysql_buildconf.patch
Patch3:         apr-util-1.2.8-dso.patch
Patch4:         apr-util-1.2.8-dbd.patch
Patch5:         apr-util-1.3.4-billion_laughs.patch
Patch6:         apr-util-1.2.8-CVE-2009-0023.patch
Patch7:         http://www.apache.org/dist/apr/patches/apr-util-1.x-CVE-2009-2412.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
%define apuver 1
%define includedir %{_includedir}/apr-%{apuver}

%description
A companion library to APR, the Apache Portable Runtime.



Authors:
--------
    Too many to list here -- see /usr/share/doc/packages/apache2/ABOUT_APACHE

%debug_package
%package devel
License:        Other uncritical OpenSource License; The Apache Software License
Summary:        Apache Portable Runtime (APR) Library
Group:          Development/Libraries/Other
Requires:       libapr-util1 = %{version}
Requires:       libapr1-devel
%if 0%{?suse_version} > 1020
Requires:       libexpat-devel
%endif
AutoReqProv:    on

%description devel
A companion library to APR, the Apache Portable Runtime.



Authors:
--------
    Too many to list here -- see /usr/share/doc/packages/apache2/ABOUT_APACHE

%package dbd-mysql
Summary:        DBD driver for MySQL
License:        LGPL v2.1 or later; "apr_dbd_mysql.c is distributed separately from the libapr-util1 tarball, at http://apache.webthing.com/svn/apache/apr/apr_dbd_mysql.c ..."
Group:          Development/Libraries/Other
Requires:       %{name} = %{version}

%description dbd-mysql
DBD driver for MySQL.



Authors:
--------
    Too many to list here -- see /usr/share/doc/packages/apache2/ABOUT_APACHE

%package dbd-pgsql
License:        Other uncritical OpenSource License; The Apache Software License
Summary:        DBD driver for PostgreSQL
Group:          Development/Libraries/Other
Requires:       %{name} = %{version}

%description dbd-pgsql
DBD driver for PostgreSQL.



Authors:
--------
    Too many to list here -- see /usr/share/doc/packages/apache2/ABOUT_APACHE

%package dbd-sqlite2
License:        Other uncritical OpenSource License; The Apache Software License
Summary:        DBD driver for SQLite 2
Group:          Development/Libraries/Other
Requires:       %{name} = %{version}

%description dbd-sqlite2
DBD driver for SQLite 2.



Authors:
--------
    Too many to list here -- see /usr/share/doc/packages/apache2/ABOUT_APACHE

%package dbd-sqlite3
License:        Other uncritical OpenSource License; The Apache Software License
Summary:        DBD driver for SQLite 3
Group:          Development/Libraries/Other
Requires:       %{name} = %{version}

%description dbd-sqlite3
DBD driver for SQLite 3.



Authors:
--------
    Too many to list here -- see /usr/share/doc/packages/apache2/ABOUT_APACHE

%if 0%{?opensuse_bs}
%endif

%prep
%setup -q -n apr-util-%{version}
%patch
%patch1
%if %{with_mysql}
%{__cp} -v %{S:1} dbd/
%patch2
%endif
%if %{with_dso}
%patch3 -p1
%patch4 -p1
%endif
%patch5
%patch6
%patch7 -p0

%build
export CFLAGS="$RPM_OPT_FLAGS -fPIC -DPIC"
%if 0%{?opensuse_bs}
CFLAGS="$CFLAGS -g"
%endif
rm -rf aclocal.m4 autom4te*.cache
autoheader
autoconf
%if %{with_dso}
%{__sed} -i -e '/OBJECTS_all/s, dbd/apr_dbd_[^ ]*\.lo,,g' build-outputs.mk
%endif
%configure \
	--includedir=%{includedir} \
	--with-apr=/usr/bin/apr-1-config \
	--with-expat=/usr \
	--with-ldap \
	--with-berkeley-db \
%if %{with_mysql}
	--with-mysql \
%endif
%if %{with_sqlite2} || %{with_sqlite3}
	--with-sqlite \
%endif
%if %{with_pgsql}
	--with-pgsql \
%endif
	--without-gdbm
#
make %{?jobs:-j%jobs}
%if %{?suse_version:1}0
make dox
%endif
%define helpdir 
%if %{with_dso}
%if %{with_mysql}
%if 0%{?suse_version} == 910
  # libmysqlclient_r was missing the .so link at SLES9 time (any easy workaround??)
  mkdir helpdir
  cp /usr/%_lib/libmysqlclient_r.so.12* helpdir/
  ln -s libmysqlclient_r.so.12.0.0 helpdir/libmysqlclient_r.so
  %define helpdir -Lhelpdir
%endif
%endif
%endif
%if %{with_dso}
%if %{with_mysql}
%{__make} dbd/apr_dbd_mysql.lo
libtool --mode=link --tag=CC %{__cc} -rpath %{_libdir} -avoid-version dbd/apr_dbd_mysql.lo %{helpdir} -lmysqlclient_r -o dbd/libapr_dbd_mysql.la
%endif
%if %{with_pgsql}
%{__make} dbd/apr_dbd_pgsql.lo
libtool --mode=link --tag=CC %{__cc} -rpath %{_libdir} -avoid-version dbd/apr_dbd_pgsql.lo -lpq  -o dbd/libapr_dbd_pgsql.la
%endif
%if %{with_sqlite2}
%{__make} dbd/apr_dbd_sqlite2.lo
libtool --mode=link --tag=CC %{__cc} -rpath %{_libdir} -avoid-version dbd/apr_dbd_sqlite2.lo -lsqlite -o dbd/libapr_dbd_sqlite2.la
%endif
%if %{with_sqlite3}
%{__make} dbd/apr_dbd_sqlite3.lo
libtool --mode=link --tag=CC %{__cc} -rpath %{_libdir} -avoid-version dbd/apr_dbd_sqlite3.lo -lsqlite3 -o dbd/libapr_dbd_sqlite3.la
%endif
%endif
make check
# make check doesn't notice that testdbd segfaults, so run it explicitely
pushd test
%if %{with_dso}
mkdir libs
for i in ../dbd/.libs/*.so
	do ln -sv ../$i libs/${i##*/lib}
done
%endif
make testall
LD_LIBRARY_PATH=`pwd`/libs ./testall -v || exit 1
popd

%install
make install DESTDIR=$RPM_BUILD_ROOT
%if %{?suse_version:1}0
mv docs/dox/html html
%endif
rm -f $RPM_BUILD_ROOT/%{_libdir}/aprutil.exp
%if %{with_dso}
install -d $RPM_BUILD_ROOT%{_libdir}
%if %{with_mysql}
libtool --mode=install /usr/bin/install -c -m 755 dbd/libapr_dbd_mysql.la $RPM_BUILD_ROOT%{_libdir}
mv $RPM_BUILD_ROOT%{_libdir}/{lib,}apr_dbd_mysql.so
%endif
%if %{with_pgsql}
libtool --mode=install /usr/bin/install -c -m 755 dbd/libapr_dbd_pgsql.la $RPM_BUILD_ROOT%{_libdir}
mv $RPM_BUILD_ROOT%{_libdir}/{lib,}apr_dbd_pgsql.so
%endif
%if %{with_sqlite2}
libtool --mode=install /usr/bin/install -c -m 755 dbd/libapr_dbd_sqlite2.la $RPM_BUILD_ROOT%{_libdir}
mv $RPM_BUILD_ROOT%{_libdir}/{lib,}apr_dbd_sqlite2.so
%endif
%if %{with_sqlite3}
libtool --mode=install /usr/bin/install -c -m 755 dbd/libapr_dbd_sqlite3.la $RPM_BUILD_ROOT%{_libdir}
mv $RPM_BUILD_ROOT%{_libdir}/{lib,}apr_dbd_sqlite3.so
%endif
rm -f $RPM_BUILD_ROOT%{_libdir}/libapr_dbd_*.la
%endif
# don't package these static libraries for now
rm -f $RPM_BUILD_ROOT/%_libdir/libapr_dbd_mysql.a
rm -f $RPM_BUILD_ROOT/%_libdir/libapr_dbd_pgsql.a
rm -f $RPM_BUILD_ROOT/%_libdir/libapr_dbd_sqlite2.a
rm -f $RPM_BUILD_ROOT/%_libdir/libapr_dbd_sqlite3.a

%clean
if ! test -f /.buildenv; then
	rm -rf $RPM_BUILD_ROOT
fi

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%defattr(-,root,root)
%doc CHANGES
%doc LICENSE
%doc NOTICE
%{_libdir}/libaprutil-%{apuver}.so.*
%if %{with_dso}
%if %{with_mysql}

%files dbd-mysql
%defattr(-,root,root,-)
%doc INSTALL.MySQL
%attr(755,root,root) %{_libdir}/apr_dbd_mysql.so
%endif
%if %{with_pgsql}

%files dbd-pgsql
%defattr(-,root,root,-)
%attr(755,root,root) %{_libdir}/apr_dbd_pgsql.so
%endif
%if %{with_sqlite2}

%files dbd-sqlite2
%defattr(-,root,root,-)
%attr(755,root,root) %{_libdir}/apr_dbd_sqlite2.so
%endif
%if %{with_sqlite3}

%files dbd-sqlite3
%defattr(-,root,root,-)
%attr(755,root,root) %{_libdir}/apr_dbd_sqlite3.so
%endif
%endif

%files devel
%defattr(-,root,root)
%if %{?suse_version:1}0
%doc --parents html
%endif
%dir %{includedir}
%{includedir}/*.h
%{_libdir}/libaprutil-%{apuver}.a
%{_libdir}/libaprutil-%{apuver}.la
%{_libdir}/libaprutil-%{apuver}.so
%{_bindir}/apu-%{apuver}-config
%{_libdir}/pkgconfig/apr-util-%{apuver}.pc

%changelog
* Sat Oct 10 2009 - meissner@suse.de
- fixed Overflow flaw in apr_pool and apr_rmm APIs (CVE-2009-2412,
  bnc#529591)
* Fri Jun 05 2009 - crrodriguez@suse.de
- VUL-0: libapr-util1 apr_strmatch_precompile DoS  [bnc#510301]
* Thu Jun 04 2009 - crrodriguez@suse.de
- VUL-0: apache2: "billion laughs" attack against Apache APR [bnc#509825]
* Wed Jul 18 2007 - poeml@suse.de
- fixed wrong rpm tag (Buildrequires -> Requires libexpat-devel)
* Wed Jul 18 2007 - poeml@suse.de
- make last fix buildservice compatible
- add debug_package macro in buildservice (will soon be obsolete)
* Sat Apr 28 2007 - aj@suse.de
- Add libexpat-devel to build requires.
* Wed Dec 20 2006 - poeml@suse.de
- fix sqlite plugin building for sqlite2, it wasn't linked against
  the lib
- work around mysql plugin build on SLES9 with a kludge
  (libmysqlclient_r was missing the .so link at SLES9 time
* Thu Dec 14 2006 - poeml@suse.de
- DSO-ify the build of dbd backends
* Thu Dec 14 2006 - poeml@suse.de
- add sqlite and pgsql support, and rpm-macroize it
* Wed Dec 13 2006 - mrueckert@suse.de
- added apr-util-1.2.8_dbd_mysql_buildconf.patch and
  http://apache.webthing.com/svn/apache/apr/apr_dbd_mysql.c:
  the patch and the additional .c file add mysql support to apr-dbd
* Mon Dec 11 2006 - poeml@suse.de
- update to 1.2.8
  *) Add support for Berkeley DB 4.5 to the configure scripts.
  *) Allow apr_queue.h to be included before other APR headers.
  *) Implement prepared statement support in SQLite3 DBD driver
  *) Fix to ensure that "deprecated" LDAP interfaces are still
  exposed if using OpenLDAP 2.3.
  *) Fix incorrect byte order and incorrect timestamp type
  in the fallback UUID generator used when no external UUID
  generator is detected by APR.
* Sat Oct 21 2006 - olh@suse.de
- libexpat.la was removed, look for libexpat.a also in lib64 (214240)
  build parallel
* Mon Sep 18 2006 - poeml@suse.de
- fix Buildrequires on FC and Mandriva
* Thu Jun 22 2006 - schwab@suse.de
- Don't depend on configure args being preserved.
* Tue May 30 2006 - poeml@suse.de
- fix BuildRequires for Fedora Core
- ditch krb5 from BuildRequires, since it doesn't seem to be needed
- use --with-berkeley-db
* Tue Apr 25 2006 - poeml@suse.de
- upstream 1.2.7. relevant changes:
  *) Fix apr_dbd_init to be safe to call multiple times
  *) Stop trying to link against Berkeley DB by default.
  (use --with-berkeley-db)
  *) Stop trying to link against GDBM by default. (use --with-gdbm)
  *) Fix the escape implementations for the sqlite2 and sqlite3 dbd
  back ends.
  *) Add support for Berkeley DB 4.4 to the configure scripts.
* Wed Jan 25 2006 - mls@suse.de
- converted neededforbuild to BuildRequires
* Wed Oct 12 2005 - poeml@suse.de
- update to 1.2.2
* Thu Sep 29 2005 - poeml@suse.de
- update to 1.2.1
- remove -DLDAP_DEPRECATED: all CFLAGS are derived from apr-config
* Mon Sep 26 2005 - ro@suse.de
- added LDAP_DEPRECATED to CFLAGS
* Thu Mar 24 2005 - poeml@suse.de
- update to 1.1.2
* Fri Feb 25 2005 - poeml@suse.de
- package created (1.1.0)
